/*
 * datagen.h
 *
 *  Created on: 2 sept. 2009
 *      Author: chardin-bri
 *  Utilisation de GSL pour la gnration de nombres pseudo-alatoires (license GPL)
 */

#ifndef DATAGEN_H_
#define DATAGEN_H_

#include "CRandomMother.h"

class datagen {
private :
  unsigned int seed;
  CRandomMother * random;
  long long prevtime;
  long anavalues_count;
  long boolvalues_count;
public :
  datagen(int seed);
  virtual ~datagen();
  void reset();
  unsigned int getAnaId();
  unsigned int getBoolId();
  unsigned int getUnit();
  unsigned int getInterval();
  float getAnaValue();
  float getThreshold1();
  float getThreshold2();
  bool getBoolValue();
  unsigned long long getDate();
  unsigned int getCreationDate();
  unsigned int getDestructionDate();
  void getLabel(char * label);
  void getThresholdLabel(char * label);
  unsigned char getQuality();
  void getStartEnd(long long &start, long long &end);
};

#endif /* DATAGEN_H_ */
