/*
 * dbms.h
 *
 *  Created on: 2 sept. 2009
 *      Author: chardin-bri
 */

#ifndef DBMS_H_
#define DBMS_H_

#include "datagen.h"

class dbms {
public :
  dbms();
  virtual ~dbms();

  static void print_options();
  static const char * name();
  static const char * version();
  static const char * filesystem();

  void insertAna(uint32_t anaid, char * label, uint32_t creationdate, uint32_t * destructiondate, uint32_t unit, uint32_t period, float threshold1, float threshold2);
  void insertBool(uint32_t boolid, char * label, uint32_t creationdate, uint32_t * destructiondate, char * label0, char * label1);
  void flushR0_1();
  void flushR0_2();
  void queryR0_1(uint32_t anaid, uint64_t date, float value, unsigned char quality);
  void queryR0_2(uint32_t boolid, uint64_t date, bool value, unsigned char quality);
  void queryR1_1(float value, uint32_t anaid, uint64_t date);
  void queryR1_2(bool value, uint32_t boolid, uint64_t date);
  void queryR2_1(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(uint32_t, uint64_t, float, unsigned char));
  void queryR2_2(uint32_t boolid, uint64_t start, uint64_t end,
      void (*callback)(uint32_t, uint64_t, bool, unsigned char));
  void queryR3_1(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(uint64_t));
  void queryR3_2(uint32_t boolid, uint64_t start, uint64_t end,
      void (*callback)(uint64_t));
  void queryR4(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(double));
  void queryR5(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(double));
  void queryR6(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(float, float));
  void queryR7(uint32_t anaid, uint64_t start, uint64_t end,
      void (*callback)(uint64_t, float));
  void queryR8(uint32_t anaid, uint64_t start, uint64_t end,
      float Threshold, void (*callback)(uint64_t, float));
  void queryR9(uint64_t start, uint64_t end,
      void (*callback)(const char *, uint64_t));
  void queryR10(uint64_t start, uint64_t end,
      void (*callback)(uint32_t, uint64_t));
  void queryR11_1(void (*callback)(uint32_t, float));
  void queryR11_2(void (*callback)(uint32_t, bool));
};

#endif /* DBMS_H_ */
